package com.vendor.burn.model.devices.burners;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import com.vendor.burn.Messages;
import com.vendor.burn.model.BurnContext;
import com.vendor.burn.model.define.IBurnable;
import com.vendor.burn.model.define.IFastbootProgressMonitor;
import com.vendor.burn.model.define.IUploadable;
import com.vendor.burn.model.devices.ITab;
import com.vendor.burn.model.devices.burners.FastbootBurner;
import com.vendor.burn.model.event.FastbootEvent;
import com.vendor.burn.serial.workers.AbstractBurnerWorker;
import com.vendor.burn.serial.workers.OneImageBurnerWorker;
import com.vendor.burn.ui.burners.tabs.UploadTab;
import org.eclipse.core.runtime.IStatus;
import org.eclipse.core.runtime.jobs.IJobChangeListener;
import org.eclipse.core.runtime.jobs.Job;

public class Uploader extends FastbootBurner implements IUploadable, IBurnable {
  private long length;
  
  private long address;
  
  private String path;
  
  public Uploader(BurnContext burnContext) {
    super(burnContext);
  }
  
  public IStatus checkBeforeUpload() {
    IStatus validLocalConfig = validSerialPort();
    if (!isOK(validLocalConfig))
      return validLocalConfig; 
    String loaderPath = getBurnContext().getLocalConfig().getLoaderPath();
    if (loaderPath.isEmpty())
      return error(Messages.pleaseImportLoader); 
    return null;
  }
  
  protected OneImageBurnerWorker getBurnerWorker() {
    return new OneImageBurnerWorker(getFrameSetting(), this);
  }
  
  public void upload(IFastbootProgressMonitor fastbootMonitor) {
    OneImageBurnerWorker worker = getBurnerWorker();
    worker.setProgressMonitor(fastbootMonitor);
    FastbootEvent event = fastbootMonitor.getEvent();
    Object object = new Object(this, "Upload", worker, event, fastbootMonitor);
    showProgressDialog((Job)object);
    object.addJobChangeListener((IJobChangeListener)new Object(this, fastbootMonitor));
    object.schedule();
  }
  
  public ITab getTab() {
    return (ITab)new UploadTab();
  }
  
  public long getLength() {
    return this.length;
  }
  
  public void setLength(long length) {
    this.length = length;
  }
  
  public long getAddress() {
    return this.address;
  }
  
  public void setAddress(long address) {
    this.address = address;
  }
  
  public String getPath() {
    return this.path;
  }
  
  public void setPath(String path) {
    this.path = path;
  }
}
